import { useEffect, useState } from 'react';
import BookingWrapper from '../../Layout/BookingWrapper/Index';
import Header from '../../Layout/Header/Index'
import Modal from '../../Shared/Modal/Index';
import img from '../../../assets/images/power-button_12080802.png'
import Button from '../../Base/Button/Index';
import LegendWrapper from '../LegendWrapper/Index';
import { getItem, reset, setItem } from '../../../utils/localStorage';
import styles from './styles.module.css';
import { useNavigate } from 'react-router-dom';
import { appConstants } from '../../../utils/AppConstants';

const SeatBooking = () => {

  let userId = getItem("user");
  const navigate = useNavigate();

  const [selectedSeats, setSelectedSeats] = useState();
  const [showSeatsModal, setShowSeatsModal] = useState(() => getItem("modal"));
  const [showSeatsConfirmationModal, setShowSeatsConfirmationModal] = useState(false);
  const [onOfSeats, setNoOfSeats] = useState();
  const [currentSeats, setCurrentSeats] = useState([]) // currently selecting seats before booking

  useEffect(() => {
    getSelectedSeats();
  }, [])

  const data = [
    {
      "row_id": 1,
      "columnData": [
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 1,
          "status": "reserved"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "reserved"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 6,
          "status": "reserved"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "reserved"
        },
        {
          "id": 0,
          "status": "aisle"
        }
      ]
    },
    {
      "row_id": 2,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 3,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 4,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 5,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 6,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 7,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 8,
      "columnData": [
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 1,
          "status": "reserved"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "reserved"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 6,
          "status": "reserved"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "reserved"
        },
        {
          "id": 9,
          "status": "available"
        }
      ]
    }
  ]

  const getSelectedSeats = async () => {
    const response = await fetch(`${appConstants.API_URL_SEATS}`);
    const data = await response.json();
    setSelectedSeats(data);
  }

  const editSeatsApi = async (
    id,
    body,
    newRequest
  ) => {

    try {
      const row = newRequest.row;
      const column = newRequest.seat;
      const current = selectedSeats.find((ele) => ele.userid == userId);
      const found = current.selected.find((e) => e.row == newRequest.row && e.seat == newRequest.seat);

      if (found) {
        let newSelected = current.selected.filter((e) => !(e.row === row && e.seat == column));
        const res = await fetch(`${appConstants.API_URL_SEATS}/${id}`,
          {
            method: "PATCH",
            headers: {
              'Content-Type': 'application/json'
            },
            body: JSON.stringify({ selected: newSelected })
          });
        getSelectedSeats();
        return;
      }

      await fetch(`${appConstants.API_URL_SEATS}/${id}`, {
        method: "PATCH",
        headers: {
          'Content-Type': 'application/json'
        },
        body: JSON.stringify({ selected: body })
      });
      getSelectedSeats();

    } catch (error) {
      console.log(error, "error")
    }

  }

  const createSeatApi = async (body) => {
    await fetch(`${appConstants.API_URL_SEATS}`, {
      method: "POST",
      headers: {
        'Content-Type': 'application/json'
      },
      body: JSON.stringify(body)
    });
    getSelectedSeats();
  }

  const onSelectSeats = (rowId, columnId) => {

    setCurrentSeats((prev) => {
      const found = prev.find((e) => (e.row == rowId && e.seat == columnId));
      if (found) {
        return currentSeats.filter(e => !(e.row == rowId && e.seat == columnId))
      } else {
        let obj = {
          row: rowId,
          seat: columnId
        }
        return [...prev, obj]
      }
    });

    let info = {
      id: userId,
      userid: userId,
      selected: [
        {
          row: rowId,
          seat: columnId
        }
      ]
    }
    const existingUserSeatMap = selectedSeats?.find((ele) => ele.id == userId);
    if (existingUserSeatMap) {
      // editSeatsApi(
      //   existingUserSeatMap.userid,
      //   [...info.selected, ...existingUserSeatMap.selected],
      //   {
      //     row: rowId,
      //     seat: columnId
      //   }
      // );
    } else {
      // createSeatApi(info);
    }
  }

  const logout = () => {
    reset();
    navigate("/login");
  }

  const onModalChange = (value) => {
    setNoOfSeats(value);
  }

  const modalClose = () => {
    setItem("modal", false);
    setShowSeatsModal(false)
  }

  const onSeatsConfirm = () => {
    setShowSeatsConfirmationModal(true)
  }

  const seatsFinal = () => {
    setShowSeatsConfirmationModal(false)
  }

  return (
    <div className={styles['seat-booking-wrapper']}>
      <img
        src={img}
        className={styles['logout']}
        width={30}
        onClick={() => logout()}
      />
      <div>
        <Header>Choose  Seats</Header>
      </div>
      <div>
        <BookingWrapper
          seatData={data}
          selectedSeats={selectedSeats}
          onSeatClick={onSelectSeats}
          currentSeats= {currentSeats}
        />
      </div>
      <div className={styles['btn-wrapper']}>
        <Button size={"md"} onClick={onSeatsConfirm}>Confirm</Button>
      </div>
      <LegendWrapper />
      {showSeatsModal
        &&
        <Modal
          onConfirm={modalClose}
          onChange={onModalChange}
        />
      }
      {showSeatsConfirmationModal
        &&
        <Modal
          onConfirm={seatsFinal}
          onChange={onModalChange}
        />
      }
    </div>
  )
}

export default SeatBooking;