import { useEffect, useState } from 'react';
import BookingWrapper from '../../Layout/BookingWrapper/Index';
import Header from '../../Layout/Header/Index'
import Modal from '../../Shared/Modal/Index';
import img from '../../../assets/images/power-button_12080802.png'
import Button from '../../Base/Button/Index';
import LegendWrapper from '../LegendWrapper/Index';
import { getItem, reset } from '../../../utils/localStorage';
import styles from './styles.module.css';

const SeatBooking = () => {
  let userId;
  const [selectedSeats, setSelectedSeats] = useState();
  useEffect(() => {
   userId = getItem("user")
  }, [])


  useEffect(() => {
    getSelectedSeats();
  }, [])

  const data = [
    {
      "row_id": 1,
      "columnData": [
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 1,
          "status": "reserved"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "reserved"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 6,
          "status": "reserved"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "reserved"
        },
        {
          "id": 0,
          "status": "aisle"
        }
      ]
    },
    {
      "row_id": 2,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 3,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 4,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 5,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 6,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 7,
      "columnData": [
        {
          "id": 1,
          "status": "available"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "available"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 6,
          "status": "available"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "available"
        },
        {
          "id": 9,
          "status": "available"
        },
        {
          "id": 10,
          "status": "available"
        }
      ]
    },
    {
      "row_id": 8,
      "columnData": [
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 1,
          "status": "reserved"
        },
        {
          "id": 2,
          "status": "available"
        },
        {
          "id": 3,
          "status": "reserved"
        },
        {
          "id": 4,
          "status": "available"
        },
        {
          "id": 0,
          "status": "aisle"
        },
        {
          "id": 5,
          "status": "available"
        },
        {
          "id": 6,
          "status": "reserved"
        },
        {
          "id": 7,
          "status": "available"
        },
        {
          "id": 8,
          "status": "reserved"
        },
        {
          "id": 9,
          "status": "available"
        }
      ]
    }
  ]


  const getSelectedSeats = async () => {
    const response = await fetch("http://localhost:3000/selectedSeats");
    const data = await response.json();
    setSelectedSeats(data);
  }

  const editSeatsApi = async (id, body, newRequest) => {
    try {
      const row = newRequest.row;
      const column = newRequest.seat;
      const current = selectedSeats.find((ele) => ele.userid == userId);
      const found = current.selected.find((e) => e.row == newRequest.row && e.seat == newRequest.seat);

      if (found) {
        let newSelected = current.selected.filter((e) => !(e.row === row && e.seat == column));
        const res = await fetch(`http://localhost:3000/selectedSeats/${id}`, {
          method: "PATCH",
          headers: {
            'Content-Type': 'application/json'
          },
          body: JSON.stringify({ selected: newSelected })
        });
        getSelectedSeats();
        return;
      }

      const res = await fetch(`http://localhost:3000/selectedSeats/${id}`, {
        method: "PATCH",
        headers: {
          'Content-Type': 'application/json'
        },
        body: JSON.stringify({ selected: body })
      });
      getSelectedSeats();

    } catch (error) {
      console.log(error, "error")
    }

  }


  const createSeatApi = async (body) => {
    console.log(body, 'Inside create')
    await fetch(`http://localhost:3000/selectedSeats`, {
      method: "POST",
      headers: {
        'Content-Type': 'application/json'
      },
      body: JSON.stringify(body)
    });
    getSelectedSeats();
  }


  const onSelectSeats = (rowId, columnId) => {
    let info = {
      id: userId,
      userid: userId,
      selected: [
        {
          row: rowId,
          seat: columnId
        }
      ]
    }
    getSelectedSeats();
    const existingUserSeapMap = selectedSeats?.find((ele) => ele.id == userId);
    if (existingUserSeapMap) {
      editSeatsApi(existingUserSeapMap.userid, [...info.selected, ...existingUserSeapMap.selected], {
        row: rowId,
        seat: columnId
      })
    } else {
      createSeatApi(info)
    }
  }

  return (
    <div className={styles['seat-booking-wrapper']}>
      <img src={img} className={styles['logout']} width={30} onClick={()=>reset()}/>
      <div>
        <Header>Choose  Seats</Header>
      </div>
      <div>
        <BookingWrapper seatData={data} selectedSeats={selectedSeats} onSeatClick={onSelectSeats} />
      </div>
      <div className={styles['btn-wrapper']}>
        <Button size={"md"}>Confirm</Button>
      </div>
      <LegendWrapper />
    </div>
  )
}

export default SeatBooking;